/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.forceten.application.action;

import javax.annotation.Nonnull;
import java.util.List;
import org.openide.util.actions.CookieAction;
import it.tidalwave.netbeans.util.Locator;
import it.tidalwave.netbeans.util.actions.GenericCapabilityAction;
import it.tidalwave.geo.geocoding.GeoCoderEntity;
import it.tidalwave.geo.explorer.role.SelectionHandler;
import it.tidalwave.geo.explorer.GeoExplorerPresentation;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public final class ShowGeoEntityAction extends GenericCapabilityAction<GeoCoderEntity>
  {
    public ShowGeoEntityAction()
      {
        super(GeoCoderEntity.class);
      }

    @Override
    protected void performAction (@Nonnull final List<GeoCoderEntity> geoEntities)
      throws Exception
      {
        Locator.find(GeoExplorerPresentation.class).getLookup().
                lookup(SelectionHandler.class).handleSelection(geoEntities);
      }

    @Override
    protected int mode()
      {
        return CookieAction.MODE_ALL;
      }
  }

