/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.forceten.application.action;

import javax.annotation.Nonnull;
import java.util.List;
import org.openide.util.Lookup;
import org.openide.util.actions.CookieAction;
import org.openide.util.lookup.Lookups;
import org.netbeans.platformx.eventbus.api.EventBus;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.util.Task;
import it.tidalwave.netbeans.util.Locator;
import it.tidalwave.netbeans.util.actions.GenericCapabilityAction;
import it.tidalwave.netbeans.aspect.Aspects;
import it.tidalwave.geo.location.GeoLocation;
import it.tidalwave.geo.location.GeoLocationSet;
import it.tidalwave.geo.location.GeoSchema;
import it.tidalwave.geo.location.GeoSchemaManager;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public final class ShowGeoLocationAction extends GenericCapabilityAction<GeoLocation>
  {
    public ShowGeoLocationAction()
      {
        super(GeoLocation.class);
      }

    @Override
    protected void performAction (final @Nonnull List<GeoLocation> geoLocations)
      throws NotFoundException
      {
//      final Lookup transactionalAspects = Lookups.fixed(new SesameTransactionalAspectFactory()); FIXME
        final Lookup transactionalAspects = Lookups.fixed();

        Aspects.run(transactionalAspects, new Task<Void, NotFoundException>()
          {
            @Override
            public Void run()
              throws NotFoundException
              {
                final GeoSchemaManager geoSchemaManager = Locator.find(GeoSchemaManager.class);
                final GeoSchema geoSchema = geoSchemaManager.findSchemaByName("GeoNames"); // FIXME
                EventBus.getDefault().publish(new GeoLocationSet(geoSchema, geoLocations));
                return null;
              }
          });
      }

    @Override
    protected int mode()
      {
        return CookieAction.MODE_ALL;
      }
  }

