/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.examples.example1;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import java.util.Locale;
import org.openide.nodes.Node;
import it.tidalwave.geo.geocoding.GeoCoderEntity;
import it.tidalwave.netbeans.nodes.FilteredNodePresentationModel;
import it.tidalwave.netbeans.nodes.ObjectFilter;
import it.tidalwave.netbeans.nodes.role.NodeDecorator;
import static it.tidalwave.role.LocalizedDisplayable.LocalizedDisplayable;

/**
 *
 * @author fritz
 */
public class SampleNodeDecorator implements NodeDecorator
  {
    @Override @Nonnull
    public Node decorate (final @Nonnull Node node)
      {
        final ObjectFilter<GeoCoderEntity> objectFilter = new ObjectFilter<GeoCoderEntity>()
          {
            @Override
            public boolean accept (final @CheckForNull GeoCoderEntity geoEntity)
              {
                return (geoEntity == null)
                       || geoEntity.as(LocalizedDisplayable).getDisplayName(Locale.ENGLISH).matches("^[AE].*");
              }
          };
          
        return new FilteredNodePresentationModel<GeoCoderEntity>(node, objectFilter, GeoCoderEntity.class);
      }
  }
