/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.impl;

import javax.annotation.Nonnull;
import it.tidalwave.geo.GeoContainer;
import it.tidalwave.geo.GeoFinder;

/***********************************************************************************************************************
 *
 * @author Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class GeoContainerImpl implements GeoContainer
  {
    @Nonnull
    private final Object owner;

    public GeoContainerImpl (final @Nonnull Object owner)
      {
        this.owner = owner;
      }

    @Override @Nonnull
    public <T> GeoFinder<T> find (final @Nonnull Class<T> type)
      {
        return new DefaultGeoFinder<T>(owner).ofType(type);
      }
  }
