/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo;

import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;

/***********************************************************************************************************************
 *
 * @author Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class CoordinateTest
  {
    @Test
    public void shouldReturnTheCorrectAttributes()
      {
        final Coordinate c1 = new Coordinate(1.0, 2.0, 3.0);
        assertThat(c1.getLatitude(),  is(1.0));
        assertThat(c1.getLongitude(), is(2.0));
        assertThat(c1.getAltitude(),  is(3.0));

        final Coordinate c2 = new Coordinate(4.0, 5.0);
        assertThat(c2.getLatitude(),  is(4.0));
        assertThat(c2.getLongitude(), is(5.0));
        assertThat(c2.getAltitude(),  is(0.0));
      }


    @Test
    public void shouldReturnTheProperToString()
      {
        final Coordinate c1 = new Coordinate(45.3059, 9.239, 485.9);
        assertThat(c1.toString(), is("N 45\u00b0 18' 21.240\" E 9\u00b0 14' 20.400\", 485.9"));

        final Coordinate c2 = new Coordinate(-20.394, -8.30, 394.7);
        assertThat(c2.toString(), is("S 20\u00b0 23' 38.400\" W 8\u00b0 18' 00.000\", 394.7"));
      }
  }