/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.geocoding.node.impl;

import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;
import javax.swing.Icon;
import org.openide.util.Lookup;
import it.tidalwave.swing.IconResizer;  
import it.tidalwave.role.IconProvider;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.netbeans.util.DeferredIconProvider;
import it.tidalwave.geo.geocoding.GeoCoderEntity;
import org.openide.util.ImageUtilities;
import static it.tidalwave.geo.geocoding.GeoCoderEntity.EmblemFactory.EmblemFactory;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class EmblemIconProviderDecorator extends DeferredIconProvider
  {
    @Nonnull
    private final Lookup lookup;

    public EmblemIconProviderDecorator (final @Nonnull IconProvider iconProviderDelegate,
                                        final @Nonnull Lookup lookup)
      {
        super(iconProviderDelegate);
        this.lookup = lookup;
      }

    @Override
    protected Icon createIcon (final @Nonnegative int size)
      throws NotFoundException
      {
        final GeoCoderEntity geoCoderEntity = NotFoundException.throwWhenNull(lookup.lookup(GeoCoderEntity.class), "");
        return ImageUtilities.image2Icon(IconResizer.scaledImage(geoCoderEntity.as(EmblemFactory).findEmblem(size), size));
      }

    @Override
    public void setIcon (Icon icon)
      {
        throw new UnsupportedOperationException(""); // FIXME: drop this
      }
  }
