/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.explorer.impl.role;

import javax.annotation.Nonnull;
import javax.annotation.concurrent.ThreadSafe;
import javax.inject.Inject;
import org.openide.nodes.Node;
import org.openide.util.lookup.ServiceProvider;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.netbeans.role.DataLoader;
import it.tidalwave.geo.explorer.GeoExplorerPresentation;
import it.tidalwave.geo.geocoding.GeoCoderManager;
import it.tidalwave.netbeans.nodes.role.NodeDataLoader;
import it.tidalwave.netbeans.nodes.role.RootNodeProvider;

/***********************************************************************************************************************
 *
 * The default {@link DataLoader} for {@link GeoExplorerPresentation}, retrieves data from the default
 * {@link it.tidalwave.geo.geocoding.GeoCoder GeoCoder}.
 * 
 * @stereotype Role
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@ThreadSafe
//@ServiceProvider(service=NodeDataLoader.class, path=GeoExplorerPresentation.ROLE_DATA_LOADER)
public final class DefaultGeoCoderDataLoader extends NodeDataLoader
  {
    @Inject
    private GeoCoderManager geoCoderManager;

    @Override
    @Nonnull
    protected Node getRootNode()
      throws NotFoundException
      {
        return geoCoderManager.findDefaultGeoCoder().getLookup().lookup(RootNodeProvider.class).getRootNode();
      }
  }
