/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.explorer;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.JFrame;
import javax.swing.WindowConstants;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.view.BeanTreeView;
import org.junit.Test;
import it.tidalwave.geo.geocoding.GeoCoder;
import it.tidalwave.geo.geocoding.GeoCoderManager;
import static it.tidalwave.geo.geocoding.GeoCoderManager.GeoCoderManager;
import it.tidalwave.netbeans.nodes.role.RootNodeProvider;
import it.tidalwave.netbeans.util.Locator;
import it.tidalwave.util.NotFoundException;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;

class GeoExplorerTestFrame extends JFrame implements ExplorerManager.Provider
  {
    private final ExplorerManager explorerManager = new ExplorerManager();
    private final BeanTreeView treeView = new BeanTreeView();

    public GeoExplorerTestFrame()
      throws NotFoundException
      {
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        final Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width - 400) / 2, (screenSize.height - 600) / 2, 400, 600);
        getContentPane().add(treeView, BorderLayout.CENTER);
        final GeoCoder geoCoder = Locator.find(GeoCoderManager.class).findDefaultGeoCoder();
        explorerManager.setRootContext(geoCoder.getLookup().lookup(RootNodeProvider.class).getRootNode());
      }

    @Override
    public ExplorerManager getExplorerManager()
      {
        return explorerManager;
      }
  }

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class GeoExplorerPresentationVisualTest
  {
    @Test
    public void dummy()
      {
      }

//    @Test
    public void testIntegrationVisually()
      throws Exception
      {
        assertThat(Locator.find(GeoCoderManager).findDefaultGeoCoder(), is(not(nullValue())));
        
        final GeoExplorerTestFrame frame = new GeoExplorerTestFrame();
        frame.setVisible(true);
        long time = System.currentTimeMillis();
        
        while (frame.isVisible() && (System.currentTimeMillis() - time < 10000))
          {
            Thread.sleep(100);  
          }
      }
  }