/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.location;

import javax.annotation.Nonnull;
import org.openide.util.Lookup;
import it.tidalwave.util.As;
import it.tidalwave.geo.location.GeoLocation.Finder;

/***********************************************************************************************************************
 *
 * @author Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public interface GeoSchema extends Lookup.Provider, As
  {
    public final static Class<GeoSchema> GeoSchema = GeoSchema.class;

    /*******************************************************************************************************************
     *
     * Returns the root {@link GeoLocation} of this schema.
     *
     * @return  the root {@code GeoLocation}
     *
     ******************************************************************************************************************/
    @Nonnull
    public GeoLocation getRoot();

    /*******************************************************************************************************************
     *
     * Finds some {@link GeoLocation}s according to a criterion. For instance,
     *
     * <pre>
     * List<? extends GeoLocation> results = geoSchema.findLocations().closeTo(new Coordinate(45, 11), 5.0).results();
     * </pre>
     *
     ******************************************************************************************************************/
    @Nonnull
    public Finder findLocations();
  }
