/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.location.elmo;

/***********************************************************************************************************************
 *
 * @author Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public final class GeoVocabulary
  {
    private GeoVocabulary()
      {
      }

    public static final String NS_GEO = "http://www.tidalwave.it/rdf/geo/2009/02/22#";
    public static final String URI_GEO_SCHEMA = NS_GEO + "schema";
    public static final String URI_GEO_LOCATION = NS_GEO + "location"; // FIXME: consider dc:Point
    public static final String URI_GEO_ENTITY = NS_GEO + "entity";
    public static final String URI_CODE = NS_GEO + "code";
    public static final String URI_TYPE = NS_GEO + "type";
    public static final String URI_LATEST_CHILDREN_QUERY_TIME = NS_GEO + "latestChildrenQueryTime";
    public static final String URI_ROOT = NS_GEO + "root";

    public static final String URI_SKOS_IN_SCHEME = "http://www.w3.org/2004/02/skos/core#inScheme";
            
    public static final String ID_PREFIX_LOCATION = "urn:tidalwave:geo/location#";

    public static final String NS_WGS84_POS = "http://www.w3.org/2003/01/geo/wgs84_pos#";

    public static final String URI_WGS84_LATITUDE = NS_WGS84_POS + "lat";
    public static final String URI_WGS84_LONGITUDE = NS_WGS84_POS + "long";
    public static final String URI_WGS84_ALTITUDE = NS_WGS84_POS + "alt";
  }
