/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.location.elmo.impl;

import it.tidalwave.role.Displayable;
import it.tidalwave.netbeans.util.test.TestLoggerSetup;
import it.tidalwave.semantic.SkosConcept;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class ElmoGeoSchemaTest
  {
    @BeforeClass
    public static void setupLogging()
      {
        TestLoggerSetup.setupLogging(ElmoGeoLocationIntegrationTestSupport.class);
      }

    @Test
    public void shouldImplementDisplayableWithSKOS()
      {
        final ElmoGeoLocation fixture = new ElmoGeoLocation();
        assertThat(fixture.as(Displayable.class), instanceOf(SkosConcept.class));
      }
  }
