/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.location.elmo.impl;

import javax.annotation.Nonnull;
import javax.xml.namespace.QName;
import it.tidalwave.semantic.IdFactory;

/***********************************************************************************************************************
 *
 * Tests the functions of the API starting from a scratch repository, populating it with data from the remote GeoCoder.
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class TestIdFactory implements IdFactory // FIXME: move to a reusable module
  {
    private static int counter;
    private static TestIdFactory instance;

    private TestIdFactory()
      {
      }

    @Nonnull
    public static synchronized IdFactory getInstance()
      {
        if (instance == null)
          {
            instance = new TestIdFactory();
          }

        return instance;
      }

    @Override @Nonnull
    public synchronized QName createId (final @Nonnull String nameSpace)
      {
        return new QName(nameSpace, String.format("%08d", counter++));
      }
  }
