/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.location.mock;

import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.geo.Coordinate;
import it.tidalwave.geo.location.GeoLocation;
import it.tidalwave.geo.location.GeoLocation.Finder;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class MockFinderSupport implements Finder
  {
    @Nonnull
    private final List<? extends GeoLocation> results;

    public MockFinderSupport (final @Nonnull List<? extends GeoLocation> results)
      {
        this.results = results;
      }

    @Override
    @Nonnull
    public Finder withDisplayName (final @Nonnull String name)
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    @Override
    @Nonnull
    public Finder withQualifiedName (final @Nonnull String path)
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    @Override
    @Nonnull
    public Finder closeTo (final @Nonnull Coordinate coordinate, final @Nonnegative double range)
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    @Override
    @Nonnegative
    public int count()
      {
        return results.size();
      }

    @Override
    @Nonnull
    public Finder from (final @Nonnegative int firstResult)
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    @Override
    @Nonnull
    public Finder max (final @Nonnegative int maxResults)
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    @Override
    @Nonnull
    public <X> it.tidalwave.util.Finder<X> ofType (final @Nonnull Class<X> type)
      {
        throw new UnsupportedOperationException("Not supported.");
      }

    @Override
    @Nonnull
    public GeoLocation result()
      throws NotFoundException
      {
        switch (results.size())
          {
            case 0:  throw new NotFoundException();
            case 1:  return results.get(0);
            default: throw new RuntimeException("Multiple results");
          }
      }

    @Override
    @Nonnull
    public GeoLocation firstResult()
      throws NotFoundException
      {
        if (results.isEmpty())
          {
            throw new NotFoundException();
          }

        return results.get(0);
      }

    @Override
    @Nonnull
    public List<? extends GeoLocation> results()
      {
        return new CopyOnWriteArrayList<GeoLocation>(results);
      }

    @Override
    @Nonnull
    public Finder sort (SortCriterion criterion, SortDirection direction)
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    @Override
    @Nonnull
    public Finder sort (SortCriterion criterion)
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }
  }
