/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.location.mock;

import javax.annotation.Nonnull;
import java.util.Arrays;
import java.util.Locale;
import java.util.SortedSet;
import java.util.TreeSet;
import org.openide.util.Lookup;
import it.tidalwave.geo.Coordinate;
import it.tidalwave.geo.location.GeoLocation;
import it.tidalwave.geo.location.GeoLocation.Finder;
import it.tidalwave.geo.location.GeoSchema;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class MockGeoSchema implements GeoSchema
  {
    private final GeoLocation root;

    public MockGeoSchema()
      {
        final MockGeoLocation genova = new MockGeoLocation(new Coordinate(0, 0), "Genova");
        final MockGeoLocation provinciaDiGenova = new MockGeoLocation(new Coordinate(0, 0), "Provincia di Genova", genova);
        final MockGeoLocation liguria = new MockGeoLocation(new Coordinate(0, 0), "Liguria", provinciaDiGenova);
        final MockGeoLocation italy = new MockGeoLocation(new Coordinate(0, 0), "Italy", liguria);
        final MockGeoLocation europe = new MockGeoLocation(new Coordinate(0, 0), "Europe", italy);
        root = new MockGeoLocation(new Coordinate(0, 0), "Earth", europe);
      }

    @Override
    @Nonnull
    public GeoLocation getRoot()
      {
        return root;
      }

    @Override
    @Nonnull
    public Finder findLocations()
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    @Override
    @Nonnull
    public Lookup getLookup()
      {
        return Lookup.EMPTY;
      }

    @Override
    @Nonnull
    public <T> T as(Class<T> clazz)
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    @Override
    @Nonnull
    public <T> T as(Class<T> clazz, NotFoundBehaviour<T> notFoundBehaviour)
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }
  }
