/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.location.mock;

import javax.annotation.Nonnull;
import java.util.Arrays;
import java.util.SortedSet;
import java.util.TreeSet;
import it.tidalwave.geo.location.GeoSchema;
import it.tidalwave.geo.location.GeoSchemaManager;
import it.tidalwave.role.Displayable;
import it.tidalwave.util.NotFoundException;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class MockGeoSchemaManager implements GeoSchemaManager
  {
    private final MockGeoSchema mockGeoSchema = new MockGeoSchema();

    @Override
    public GeoSchema findSchemaByName (final @Nonnull String name)
      throws NotFoundException
      {
        return mockGeoSchema;
      }

    @Override
    public SortedSet<String> getSchemaNames()
      {
        return new TreeSet<String>(Arrays.asList(mockGeoSchema.as(Displayable.class).getDisplayName()));
      }
  }
