/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.location.node.impl;

import it.tidalwave.geo.location.GeoSchema;
import it.tidalwave.geo.location.GeoSchemaManager;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.netbeans.util.Locator;
import it.tidalwave.netbeans.util.test.MockLookup;
import it.tidalwave.netbeans.util.test.TestLoggerSetup;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;
import static org.hamcrest.CoreMatchers.*;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class TestSupport
  {
    protected static GeoSchemaManager geoSchemaManager;
    protected static GeoSchema geoSchema;

    @BeforeClass
    public static void installMockGeoNodeManager()
      throws NotFoundException
      {
        TestLoggerSetup.setupLogging(TestLoggerSetup.class);
        geoSchema = mock(GeoSchema.class);

        geoSchemaManager = mock(GeoSchemaManager.class);
        when(geoSchemaManager.findSchemaByName(anyString())).thenReturn(geoSchema);

        MockLookup.setInstances(geoSchemaManager);
        assertThat(Locator.find(GeoSchemaManager.class).findSchemaByName("GeoNames"), sameInstance(geoSchema));
      }

    @AfterClass
    public static void uninstallMockGeoNodeManager()
      {
        MockLookup.setInstances();
      }
  }
