/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.geocoding.impl.finder;

import it.tidalwave.util.NotFoundException;
import it.tidalwave.geo.Coordinate;
import it.tidalwave.geo.geocoding.GeoCoderEntity;
import it.tidalwave.netbeans.util.test.TestLoggerSetup;
import org.junit.BeforeClass;
import static it.tidalwave.role.Displayable.Displayable;
import static it.tidalwave.geo.GeoContainer.GeoContainer;
import static it.tidalwave.geo.geocoding.GeoCoderEntity.GeoCoderEntity;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class CoordinateFinderIntegrationTest
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @BeforeClass
    public static void setupLogging()
      {
        TestLoggerSetup.setupLogging(CoordinateFinderIntegrationTest.class);
      }

    @Test
    public void mustFindQuistelloAt45N11W()
      throws NotFoundException
      {
        final GeoCoderEntity entity = new Coordinate(45, 11).as(GeoContainer).find(GeoCoderEntity).result();
        assertThat(entity, is(notNullValue()));
        assertThat(entity.getId(), is("3169656"));
        assertThat(entity.as(Displayable).getDisplayName(), is("Quistello"));
        assertThat(entity.getCoordinate(), is (new Coordinate(45.00558, 10.9823, 0)));
      }
  }