/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.node.flagsoftheworld;

import javax.annotation.Nonnull;
import org.openide.nodes.Node;
import it.tidalwave.netbeans.nodes.role.NodeDecorator;
import it.tidalwave.geo.node.flagsoftheworld.impl.GeoEntityNodeWithFlags;

/***********************************************************************************************************************
 *
 * A decorator for {@link Node}s which attaches the flags of the states of the world.
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class GeoNodeFlagsOfTheWorldDecorator implements NodeDecorator
  {
    @Override
    @Nonnull
    public Node decorate (final @Nonnull Node node)
      {
        return new GeoEntityNodeWithFlags(node);
      }
}
