/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer;

import javax.annotation.concurrent.ThreadSafe;
import org.openide.util.Lookup;
import it.tidalwave.netbeans.util.Locator.ImplementedBy;
import it.tidalwave.geo.viewer.impl.GeoViewerTopComponent;

/***********************************************************************************************************************
 *
 * This component provides a visual component for rendering 2D and 3D representations of geographic areas.
 *
 * This component does not expose a single interface for services; instead, it works as a factory where specific
 * services can be looked up.
 *
 * Please refer to the package documentation for more information: {@link it.tidalwave.geo.viewer}.
 *
 * @has - - - org.openide.util.Lookup
 * @has - - - it.tidalwave.geo.viewer.GeoViewManager
 * @has - - - it.tidalwave.geo.viewer.GeoViewProviderManager
 * @has - - - it.tidalwave.geo.viewer.FeatureManager
 * @has - - - it.tidalwave.geo.viewer.role.CacheLocationProvider
 * @has - - - it.tidalwave.geo.viewer.role.InitialLocationProvider
 * @has - - - it.tidalwave.geo.viewer.role.impl.EventBusGeoEntitySetListener
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@ThreadSafe @ImplementedBy(GeoViewerTopComponent.class)
public interface GeoViewerPresentation extends Lookup.Provider
  {
    public static final String ID = "it.tidalwave.geo.viewer.GeoViewerPresentation";
  }
