/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.impl.spi;

import javax.annotation.Nonnull;
import java.awt.Component;
import java.awt.Point;
import javax.swing.JComponent;
import javax.swing.JPanel;
import it.tidalwave.geo.Coordinate;
import it.tidalwave.geo.Sector;
import it.tidalwave.geo.viewer.spi.GeoViewProviderSupport;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public final class VoidGeoViewProvider extends GeoViewProviderSupport
  {
    private final JComponent voidComponent = new JPanel();
    
    public VoidGeoViewProvider()
      {
        super("VOID", 1);
      }

    @Override
    public int getMaximumZoomLevel()
      {
        return 1;
      }

    @Override
    public int getMinimumZoomLevel()
      {
        return 1;
      }

    @Override
    public void setZoom (int zoom)
      {
      }

    @Override
    public int getZoom()
      {
        return 1;
      }

    @Override
    public Point coordinatesToPoint (final @Nonnull Coordinate coordinates)
      {
        return new Point(0, 0);
      }

    @Override
    @Nonnull
    public Coordinate pointToCoordinates (final @Nonnull Point point)
      {
        return new Coordinate(0, 0);
      }

    @Override
    public void fitView (final @Nonnull Sector sector)
      {
      }

    @Override
    public void pan (final double x, final double y)
      {
      }

    @Override
    public void setCenterPosition (final @Nonnull Coordinate centerPosition)
      {
      }

    @Override
    @Nonnull
    public Coordinate getCenterPosition()
      {
        return new Coordinate(0, 0);
      }

    @Override
    @Nonnull
    public Component getRendererComponent() 
      {
        return voidComponent;
      }
  }
