/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.role;

import javax.annotation.Nonnull;
import it.tidalwave.geo.Coordinate;

/***********************************************************************************************************************
 *
 * This role provides the initial location that the geographical view is centered on at startup. Concrete
 * implementations could return a fixed location, a location dependent on the current IP address, a location stored in
 * the preferences, etc.
 *
 * @see ZeroZeroInitialLocationProvider
 *
 * @stereotype Role
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public interface InitialLocationProvider
  {
    /*******************************************************************************************************************
     *
     * Returns the initial coordinate.
     *
     * @return  the initial coordinate
     *
     ******************************************************************************************************************/
    @Nonnull
    public Coordinate getInitialCoordinate();
  }
