/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.spi.feature;

import java.awt.Dimension;
import java.awt.Graphics2D;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public interface FeatureRenderer<T>
  {
    /***************************************************************************
     *
     * Paints a waypoint.
     *
     * @param   g          the Graphics2D (maybe null for mere size inquire)
     * @param   feature    the feature to paint
     * @param   x          the x offset
     * @param   y          the y offset
     * @param   pedestal   true if a pedestal should be rendered
     * @param   size       this must be filled with the current sizes
     *
     **************************************************************************/
    public boolean paintFeature (Graphics2D g, T feature, int x, int y, boolean pedestal, Dimension size);
  }

