/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.widget;

import javax.annotation.Nonnull;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.awt.Color;
import org.openide.util.Lookup;
import org.openide.nodes.Node;
import org.netbeans.api.visual.widget.Scene;
import org.netbeans.api.visual.widget.general.IconNodeWidget;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class SimpleGeoWidget extends IconNodeWidget
  {
    @Nonnull
    private final Node node;

    public SimpleGeoWidget (final @Nonnull Scene scene, final @Nonnull Node node)
      {
        super(scene, TextOrientation.RIGHT_CENTER);
        setLabel(node.getDisplayName());
        setImage(node.getIcon(0));
        setOpaque(false);
        setBorder(org.netbeans.api.visual.border.BorderFactory.createRoundedBorder(4, 4, Color.WHITE, Color.BLACK));
        this.node = node;

        node.addPropertyChangeListener(new PropertyChangeListener()
          {
            @Override
            public void propertyChange (final @Nonnull PropertyChangeEvent event)
              {
                if (Node.PROP_ICON.equals(event.getPropertyName()))
                  {
                    setImage(node.getIcon(0));
                  }
              }
          });
      }

    @Override @Nonnull
    public Lookup getLookup()
      {
        return node.getLookup();
      }

    @Override @Nonnull
    public String toString()
      {
        return String.format("SimpleGeoWidget@%x[%s]", System.identityHashCode(this), node);
      }
  }
