/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.spi.jxmapviewer;

import javax.annotation.Nonnull;
import org.jdesktop.swingx.mapviewer.GeoPosition;
import it.tidalwave.geo.Coordinate;

/***********************************************************************************************************************
 *
 * Convenience class which provides translation from a {@link GeoPosition} to a {@link Coordinate}.
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public final class CoordinateConverter
  {
    private CoordinateConverter()
      {
      }

    @Nonnull
    public static Coordinate fromGeoPosition (final @Nonnull GeoPosition geoPosition)
      {
        return new Coordinate(geoPosition.getLatitude(), geoPosition.getLongitude());
      }

    @Nonnull
    public static GeoPosition toGeoPosition (final @Nonnull Coordinate coordinates)
      {
        return new GeoPosition(coordinates.getLatitude(), coordinates.getLongitude());
      }
  }
