/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.spi.jxmapviewer;

import javax.annotation.Nonnegative;
import javax.swing.JPanel;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class NavigationPane extends JPanel 
  {
    public static final String PROP_ZOOM = "zoom";
    public static final String PROP_MAX_ZOOM = "maxZoom";
    public static final String PROP_MIN_ZOOM = "minZoom";

    @Nonnegative
    private int zoom;

    public NavigationPane() 
      {
        initComponents();
      }

    public void setZoom (final @Nonnegative int zoom)
      {
        final int oldZoom = this.zoom;
        this.zoom = zoom;
        firePropertyChange(PROP_ZOOM, oldZoom, zoom);
      }

    @Nonnegative
    public int getZoom()
      {
        return zoom;
      }

    public void setMinZoom (final @Nonnegative int minZoom)
      {
        final int oldMinZoom = slZoom.getMinimum();
        slZoom.setMinimum(minZoom);
        firePropertyChange(PROP_MIN_ZOOM, oldMinZoom, minZoom);
      }

    @Nonnegative
    public int getMinZoom()
      {
        return slZoom.getMinimum();
      }

    public void setMaxZoom (final @Nonnegative int maxZoom)
      {
        final int oldMaxZoom = slZoom.getMaximum();
        slZoom.setMaximum(maxZoom);
        firePropertyChange(PROP_MAX_ZOOM, oldMaxZoom, maxZoom);
      }

    @Nonnegative
    public int getMaxZoom()
      {
        return slZoom.getMaximum();
      }
    
    /***************************************************************************
     *
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     *
     **************************************************************************/
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        slZoom = new javax.swing.JSlider();
        btZoomIn = new javax.swing.JButton();
        btZoomOut = new javax.swing.JButton();

        setBorder(new javax.swing.border.LineBorder(new java.awt.Color(255, 255, 255), 1, true));
        setOpaque(false);

        slZoom.setOrientation(javax.swing.JSlider.VERTICAL);
        slZoom.setSnapToTicks(true);

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, this, org.jdesktop.beansbinding.ELProperty.create("${zoom}"), slZoom, org.jdesktop.beansbinding.BeanProperty.create("value"));
        bindingGroup.addBinding(binding);

        btZoomIn.setFont(btZoomIn.getFont().deriveFont((float)10));
        btZoomIn.setForeground(new java.awt.Color(255, 255, 255));
        btZoomIn.setText(org.openide.util.NbBundle.getMessage(NavigationPane.class, "NavigationPane.btZoomIn.text")); // NOI18N
        btZoomIn.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btZoomIn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btZoomInActionPerformed(evt);
            }
        });

        btZoomOut.setFont(btZoomOut.getFont().deriveFont((float)10));
        btZoomOut.setForeground(new java.awt.Color(255, 255, 255));
        btZoomOut.setText(org.openide.util.NbBundle.getMessage(NavigationPane.class, "NavigationPane.btZoomOut.text")); // NOI18N
        btZoomOut.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btZoomOut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btZoomOutActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(slZoom, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(btZoomIn, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btZoomOut, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(348, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(slZoom, javax.swing.GroupLayout.PREFERRED_SIZE, 118, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btZoomIn, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btZoomOut, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(146, Short.MAX_VALUE))
        );

        bindingGroup.bind();
    }// </editor-fold>//GEN-END:initComponents

    @SuppressWarnings("PMD.UnusedFormalParameter")
    private void btZoomInActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btZoomInActionPerformed
       setZoom(getZoom() - 1);
    }//GEN-LAST:event_btZoomInActionPerformed

    @SuppressWarnings("PMD.UnusedFormalParameter")
    private void btZoomOutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btZoomOutActionPerformed
       setZoom(getZoom() + 1);
    }//GEN-LAST:event_btZoomOutActionPerformed
      
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btZoomIn;
    private javax.swing.JButton btZoomOut;
    private javax.swing.JSlider slZoom;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables
  }
