/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.spi.jxmapviewer;

import javax.annotation.Nonnull;
import java.util.Collection;
import java.util.Collections;
import org.openide.util.lookup.ServiceProvider;
import org.openide.nodes.Node;
import org.netbeans.api.visual.model.ObjectScene;
import org.netbeans.api.visual.widget.Widget;
import it.tidalwave.netbeans.capabilitiesprovider.CapabilitiesProvider;
import it.tidalwave.netbeans.capabilitiesprovider.CapabilitiesProviderSupport;
import it.tidalwave.netbeans.visual.NodeWidgetFactory;
import it.tidalwave.geo.geocoding.GeoCoderEntity;
import it.tidalwave.geo.viewer.widget.SimpleGeoWidget;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@ServiceProvider(service=CapabilitiesProvider.class)
public class NodeWidgetFactoryCapabilityProvider extends CapabilitiesProviderSupport<GeoCoderEntity>
  {
    private final NodeWidgetFactory nodeWidgetFactory = new NodeWidgetFactory()
      {
        @Override @Nonnull
        public Collection<? extends Widget> createWidgets (final @Nonnull ObjectScene scene, final @Nonnull Node node)
          {
            return Collections.singletonList(new SimpleGeoWidget(scene, node));
          }
      };

    @Override @Nonnull
    public Collection<? extends Object> createCapabilities (final @Nonnull GeoCoderEntity owner)
      {
        return Collections.singletonList(nodeWidgetFactory);
      }
  }
