/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.spi.jxmapviewer.widget;

import javax.annotation.Nonnull;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import org.openide.util.Lookup;
import org.openide.util.lookup.Lookups;
import org.netbeans.api.visual.widget.Scene;
import org.netbeans.api.visual.widget.Widget;
import it.tidalwave.netbeans.visual.NodeScene.DragBehaviour;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class GeoPinWidget extends Widget
  {
    @Nonnull
    private final Widget widget;

    @Nonnull
    private final Lookup lookup;

    public GeoPinWidget (final @Nonnull Scene scene,
                         final @Nonnull Widget widget,
                         final @Nonnull DragBehaviour dragBehaviour)
      {
        super(scene);
        this.widget = widget;
        setPreferredSize(new Dimension(11, 11));
        lookup = Lookups.fixed(dragBehaviour);
      }

    @Override @Nonnull
    public Lookup getLookup()
      {
        return lookup;
      }

    @Override
    protected void paintWidget()
      {
        final Graphics2D g = getGraphics();
        final Rectangle bounds = getBounds();
        g.setColor(Color.YELLOW);
        final int w = bounds.width;
        final int h = bounds.height;
        g.drawLine(bounds.x, bounds.y + h/2, bounds.x + w - 1, bounds.y + h/2);
        g.drawLine(bounds.x + w/2, bounds.y, bounds.x + w/2, bounds.y + h - 1);
      }

    @Override @Nonnull
    public String toString()
      {
        return String.format("GeoPinWidget@%x[%s]", System.identityHashCode(this), widget);
      }
  }