/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.spi.jxmapviewer.widget;

import javax.annotation.Nonnull;
import java.awt.Point;
import it.tidalwave.netbeans.visual.NodeScene.DragBehaviour;
import it.tidalwave.netbeans.visual.NodeScene.DragEvent;
import it.tidalwave.geo.viewer.spi.jxmapviewer.widget.OffsetWidget;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class OffsetWidgetDragBehaviour implements DragBehaviour
  {
    private Point startLocation;
    private int offsetX;
    private int offsetY;

    @Override
    public void nodeDragStarted (final @Nonnull DragEvent event)
      {
        startLocation = new Point(event.getLocation());
      }

    @Override
    public void nodeDragged (final @Nonnull DragEvent event)
      {
        final Point location = event.getLocation();
        offsetX = location.x - startLocation.x;
        offsetY = location.y - startLocation.y;
      }

    @Override
    public void nodeDragFinished (final @Nonnull DragEvent event, final @Nonnull Confirmation confirmation)
      {
        final OffsetWidget widget = (OffsetWidget)event.getWidget();
        widget.translateOffset(offsetX, offsetY);
      }

    @Override
    public Confirmation confirmDrag (final @Nonnull DragEvent event)
      {
        return Confirmation.CONFIRMED;
      }
  }
