/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.spi.jxmapviewer;

import java.awt.EventQueue;
import it.tidalwave.netbeans.windows.EnhancedTopComponent;
import it.tidalwave.netbeans.windows.EnhancedWindowManager;
import it.tidalwave.geo.viewer.GeoViewerPresentation;
import it.tidalwave.netbeans.util.Locator;
import it.tidalwave.netbeans.util.test.MockLookup;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.mockito.Mockito.*;
import static org.hamcrest.CoreMatchers.*;
import org.hamcrest.core.IsInstanceOf;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class GeoViewerTopComponentTest
  {
    private EnhancedTopComponent fixture;
    private static EnhancedWindowManager windowManager;

    @Before
    public void setUp()
      throws Exception
      {
        windowManager = mock(EnhancedWindowManager.class);
        MockLookup.setInstances(windowManager);
        fixture = Locator.find(GeoViewerPresentation.class).getLookup().lookup(EnhancedTopComponent.class);
        EventQueue.invokeAndWait(new Runnable()
          {
            @Override
            public void run()
              {
                fixture.installRoles();
              }
          });
      }

    @Test
    public void testJXMapViewerWaypointSetPainterIsPresent()
      {
        final JXMapViewerFeaturePainter role = fixture.getLookup().lookup(JXMapViewerFeaturePainter.class);
        assertThat(role, is(not(nullValue())));
        assertThat(role, IsInstanceOf.instanceOf(JXMapViewerFeaturePainter.class));
      }

    @Test
    public void testJXMapViewerSupportIsPresent()
      {
        final JXMapViewerGeoViewSupport role = fixture.getLookup().lookup(JXMapViewerGeoViewSupport.class);
        assertThat(role, is(not(nullValue())));
        assertThat(role, IsInstanceOf.instanceOf(JXMapViewerGeoViewSupport.class));
      }
  }