/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.spi.microsoftvirtualearth;

import java.awt.Dimension;
import it.tidalwave.geo.viewer.spi.TileProviderDescriptor.HorizontalLayout;
import it.tidalwave.geo.viewer.spi.TileProviderDescriptor.VerticalLayout;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public abstract class MicrosoftVirtualEarthTileProviderDescriptorTest
  {
    protected MicrosoftVirtualEarthTileProviderDescriptor fixture;

    @Test
    public void testGeneralProperties()
      {
        assertThat(fixture.getTileSize(), is(new Dimension(256, 256)));
        assertThat(fixture.getMinZoomLevel(), is(2));
        assertThat(fixture.getMaxZoomLevel(), is(17));
        assertThat(fixture.getTopZoomLevel(), is(19));
        assertThat(fixture.getInitialZoomLevel(), is(12));
        assertThat(fixture.getHorizontalLayout(), is(HorizontalLayout.LEFT_TO_RIGHT));
        assertThat(fixture.getVerticalLayout(), is(VerticalLayout.BOTTOM_TO_TOP));
      }
  }