/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.worldwindprovider.impl.layer;

import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;
import gov.nasa.worldwind.layers.RenderableLayer;
import gov.nasa.worldwind.render.Renderable;
import javax.annotation.Nonnull;
import org.openide.util.Lookup;

/***********************************************************************************************************************
 *
 * This class is responsible for rendering paths on the globe.
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class PathLayer extends RenderableLayer 
  {
    private static final String CLASS = PathLayer.class.getName();
    private static final Logger logger = Logger.getLogger(CLASS);
    
//    private static final Color COLOR = new Color(255, 255, 0, 255);
    
//    private static final Color BORDER_COLOR = Color.BLACK;
    
    private final List<Renderable> segments = new ArrayList<Renderable>();
    
//    private long latestTimestamp = 0;

//    private int firstSegmentIndex = 0;
    
//    private Renderable latestSegment = null;
            
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
//    private final WaypointViewManager.Listener waypointListener = new WaypointViewManager.Listener()
//      {
//        @Override
//        public void notifyWaypointAdded (final @Nonnull WaypointView waypoint)
//          {
//            // do nothing for simple waypoints
//          }
//
//        @Override
//        public void notifyPathWaypointsAdded (final @Nonnull Collection<WaypointView> waypoints)
//          {
//            logger.info("notifyPathWaypointsAdded(" + waypoints.size() + " points)");
//            createSegments();
//          }
//
//        @Override
//        public void notifyWaypointsCleared()
//          {
//            logger.info("notifyWaypointsCleared()");
//
//            for (final Renderable segment : segments)
//              {
//                removeRenderable(segment);
//              }
//
//            segments.clear();
//            latestSegment = null;
//            firstSegmentIndex = 0;
//          }
//
//        @Override
//        public void notifyAnimationStep()
//          {
//            logger.info("notifyAnimationStep()");
//            createSegments();
//          }
//      };
//
    private final Lookup lookup;

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public PathLayer (final @Nonnull String layerName, @Nonnull final Lookup lookup)
      {
        logger.info("PathLayer(" + layerName + ")");
        this.setName(layerName);
        this.lookup = lookup;
//        lookup.lookup(WaypointViewManager.class).addListener(waypointListener);
      }

    // Do not detach the listener on dispose() - see http://forum.worldwindcentral.com/showthread.php?p=49436
    
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
//    private void createSegments()
//      {
//        // Better safe than sorry: see http://forum.worldwindcentral.com/showthread.php?t=11407
//        if (SwingUtilities.isEventDispatchThread())
//          {
//            createSegmentsInAWTThread();
//          }
//        else
//          {
//            try
//              {
//                SwingUtilities.invokeAndWait(new Runnable()
//                  {
//                    @Override
//                    public void run()
//                      {
//                        createSegmentsInAWTThread();
//                      }
//                  });
//              }
//            catch (InterruptedException e)
//              {
//                logger.throwing(CLASS, "createSegments()", e);
//              }
//            catch (InvocationTargetException e)
//              {
//                logger.throwing(CLASS, "createSegments()", e);
//              }
//          }
//      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    private void createSegmentsInAWTThread()
      {
        logger.info("createSegments()");
//        final List<WaypointView> waypoints = lookup.lookup(WaypointViewManager.class).getRenderingWaypoints();
//        boolean firstCheck = true;
//
//        for (int index = firstSegmentIndex; index < waypoints.size(); index++)
//          {
//            final long timeStamp = waypoints.get(index).getTimestamp();
//
//            if ((index < waypoints.size() - 1) && (Math.abs(timeStamp - latestTimestamp) < 60 * 1000)) // FIXME
//              {
//                if ((latestSegment != null) && firstCheck)
//                  {
//                    removeRenderable(latestSegment);
//                    segments.remove(latestSegment);
//                  }
//
//                firstCheck = false;
//              }
//            else // last index or after a gap
//              {
//                final SurfacePolyline line = new SurfacePolyline(new WaypointToLatLonAdapter(waypoints.subList(firstSegmentIndex, index)), COLOR, COLOR);
//                logger.fine(">>>> created segment points: " + (index - firstSegmentIndex + 1));
//                firstSegmentIndex = index;
//                line.setAntiAlias(true);
//                line.setTextureSize(SurfacePolyline.TEXTURE_SIZE_1024);
//    //            line.setNumEdgeIntervalsPerDegree(10);
//    //            line.setBorderColor(BORDER_COLOR);
//                line.setStroke(new BasicStroke(4f));
//                addRenderable(line);
//                segments.add(line);
//                latestSegment = line;
//              }
//
//            latestTimestamp = timeStamp;
//          }

        logger.fine(">>>> created segments " + segments.size());
      }
  }
