/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * Copyright (C) 2007-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://forceten.tidalwave.it
 * SCM: https://bitbucket.org/tidalwave/forceten-src
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.worldwindprovider.impl.layer;

import javax.annotation.Nonnull;
import gov.nasa.worldwind.layers.Layer;
import it.tidalwave.geo.viewer.spi.TileProviderDescriptor;
import it.tidalwave.geo.viewer.worldwindprovider.spi.TiledImageLayer;
import it.tidalwave.geo.viewer.worldwindprovider.spi.LayerProvider;
import org.netbeans.platformx.inject.api.Injector;
import org.openide.util.Lookup;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class TiledImageLayerProvider implements LayerProvider
  {
    @Nonnull
    private final TileProviderDescriptor tileProviderDescriptor;

    @Nonnull
    private final Lookup lookup;

    public TiledImageLayerProvider (final @Nonnull TileProviderDescriptor tileProviderDescriptor,
                                    final @Nonnull Lookup lookup)
      {
        this.tileProviderDescriptor = tileProviderDescriptor;
        this.lookup = lookup;
      }

    @Override
    public Layer createLayer() 
      {
        final TiledImageLayer layer = new TiledImageLayer(tileProviderDescriptor);
        Injector.getDefault().inject(layer, lookup);
        return layer;
      }

    @Override
    public Layer insertBefore() 
      {
        return null;
      }

    @Override
    public boolean isActiveByDefault() 
      {
        return false;
      }
  }
